OpenVDB: DenseGridHandle< BufferT > Class Template Reference

OpenVDB 10.0.1

Loading...
Searching...
No Matches
Public Member Functions | List of all members
DenseGridHandle< BufferT > Class Template Reference

`#include <nanovdb/examples/benchmark/DenseGrid.h>`

## Public Member Functions
| DenseGridHandle (BufferT &&resources)
| DenseGridHandle ()=default
| DenseGridHandle (const DenseGridHandle &)=delete
| Disallow copy-construction.
DenseGridHandle & | operator= (const DenseGridHandle &)=delete
| Disallow copy assignment operation.
DenseGridHandle & | operator= (DenseGridHandle &&other) noexcept
| Move copy assignment operation.
| DenseGridHandle (DenseGridHandle &&other) noexcept
| Move copy-constructor.
| ~DenseGridHandle ()
| Default destructor.
void | reset ()
BufferT & | buffer ()
const BufferT & | buffer () const
uint8_t * | data ()
| Returns a non-const pointer to the data.
const uint8_t * | data () const
| Returns a const pointer to the data.
uint64_t | size () const
| Returns the size in bytes of the raw memory buffer managed by this DenseGridHandle's allocator.
template<typename ValueT >
const DenseGrid< ValueT > * | grid () const
| Returns a const pointer to the NanoVDB grid encoded in the DenseGridHandle.
template<typename ValueT >
DenseGrid< ValueT > * | grid ()
template<typename ValueT , typename U = BufferT>
std::enable_if< BufferTraits< U >::hasDeviceDual, constDenseGrid< ValueT > * >::type | deviceGrid () const
template<typename U = BufferT>
std::enable_if< BufferTraits< U >::hasDeviceDual, void >::type | deviceUpload (void *stream=nullptr, bool sync=true)
template<typename U = BufferT>
std::enable_if< BufferTraits< U >::hasDeviceDual, void >::type | deviceDownload (void *stream=nullptr, bool sync=true)

## Constructor & Destructor Documentation

## ◆ DenseGridHandle() [1/4]

template<typename BufferT >

DenseGridHandle | ( | BufferT && | resources | ) |
| inline

## ◆ DenseGridHandle() [2/4]

template<typename BufferT >

DenseGridHandle | ( |  | ) |
| default

## ◆ DenseGridHandle() [3/4]

template<typename BufferT >

DenseGridHandle | ( | const DenseGridHandle< BufferT > & |  | ) |
| delete

Disallow copy-construction.

## ◆ DenseGridHandle() [4/4]

template<typename BufferT >

DenseGridHandle | ( | DenseGridHandle< BufferT > && | other | ) |
| inlinenoexcept

Move copy-constructor.

## ◆ ~DenseGridHandle()

template<typename BufferT >

~DenseGridHandle | ( |  | ) |
| inline

Default destructor.

## Member Function Documentation

## ◆ buffer() [1/2]

template<typename BufferT >

BufferT & buffer | ( |  | ) |
| inline

## ◆ buffer() [2/2]

template<typename BufferT >

const BufferT & buffer | ( |  | ) | const
| inline

## ◆ data() [1/2]

template<typename BufferT >

uint8_t * data | ( |  | ) |
| inline

Returns a non-const pointer to the data.

Warning
  Note that the return pointer can be NULL if the DenseGridHandle was not initialized

## ◆ data() [2/2]

template<typename BufferT >

const uint8_t * data | ( |  | ) | const
| inline

Returns a const pointer to the data.

Warning
  Note that the return pointer can be NULL if the DenseGridHandle was not initialized

## ◆ deviceDownload()

template<typename BufferT >
template<typename U = BufferT>

std::enable_if< BufferTraits< U >::hasDeviceDual, void >::type deviceDownload | ( | void * | stream = `nullptr`,
|  | bool | sync = `true`
| ) |  |
| inline

## ◆ deviceGrid()

template<typename BufferT >
template<typename ValueT , typename U = BufferT>

std::enable_if< BufferTraits< U >::hasDeviceDual, constDenseGrid< ValueT > * >::type deviceGrid | ( |  | ) | const
| inline

## ◆ deviceUpload()

template<typename BufferT >
template<typename U = BufferT>

std::enable_if< BufferTraits< U >::hasDeviceDual, void >::type deviceUpload | ( | void * | stream = `nullptr`,
|  | bool | sync = `true`
| ) |  |
| inline

## ◆ grid() [1/2]

template<typename BufferT >
template<typename ValueT >

DenseGrid< ValueT > * grid | ( |  | ) |
| inline

## ◆ grid() [2/2]

template<typename BufferT >
template<typename ValueT >

const DenseGrid< ValueT > * grid | ( |  | ) | const
| inline

Returns a const pointer to the NanoVDB grid encoded in the DenseGridHandle.

Warning
  Note that the return pointer can be NULL if the DenseGridHandle was not initialized or the template parameter does not match!

## ◆ operator=() [1/2]

template<typename BufferT >

DenseGridHandle & operator= | ( | const DenseGridHandle< BufferT > & |  | ) |
| delete

Disallow copy assignment operation.

## ◆ operator=() [2/2]

template<typename BufferT >

DenseGridHandle & operator= | ( | DenseGridHandle< BufferT > && | other | ) |
| inlinenoexcept

Move copy assignment operation.

## ◆ reset()

template<typename BufferT >

void reset | ( |  | ) |
| inline

## ◆ size()

template<typename BufferT >

uint64_t size | ( |  | ) | const
| inline

Returns the size in bytes of the raw memory buffer managed by this DenseGridHandle's allocator.